/*

ExtInstCheck

Copyright (c) 2017 KINOSHITA Hidetoshi

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--------------------------------------------------------------------------

ExtInstCheck

Copyright (c) 2017 ؉pr

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\t
gEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐Ɉ
Ƃ𖳏ŋ܂Bɂ́A\tgEFA̕gpAʁAύXA
AfځAЕzATuCZXAс^܂͔̔錠Aу\tgEF
A񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
ɋLڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕
؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂
B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\
tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈
ɂĐ؂̐AQȂ̋`ɂĉ̐ӔCȂ
̂Ƃ܂B

*/


//
// _cpuid ɂ SIMDT|[g󋵊mF
//
// Refferences:
//   http://www.yamatyuu.net/computer/program/vc2013/extinstchk/index.html#wix
//   http://ja.wikipedia.org/wiki/CPUID
//   https://msdn.microsoft.com/ja-jp/library/hskdteyh.aspx
//

#include "stdafx.h"



#if 1800 <= _MSC_VER	//	Visual C++ 2013ȏ 
#include <VersionHelpers.h>
#else
#ifndef _WIN32_WINNT_WIN7
#define _WIN32_WINNT_WIN7 0x0601
#endif
inline bool IsWindowsVersionOrGreater(WORD wMajorVersion, WORD wMinorVersion, WORD wServicePackMajor){
	OSVERSIONINFOEXW osvi = { sizeof(osvi), 0, 0, 0, 0, { 0 }, 0, 0 };
	DWORDLONG        const dwlConditionMask = VerSetConditionMask(
		VerSetConditionMask(
		VerSetConditionMask(
		0, VER_MAJORVERSION, VER_GREATER_EQUAL),
		VER_MINORVERSION, VER_GREATER_EQUAL),
		VER_SERVICEPACKMAJOR, VER_GREATER_EQUAL);

	osvi.dwMajorVersion = wMajorVersion;
	osvi.dwMinorVersion = wMinorVersion;
	osvi.wServicePackMajor = wServicePackMajor;

	return VerifyVersionInfoW(&osvi, VER_MAJORVERSION | VER_MINORVERSION | VER_SERVICEPACKMAJOR, dwlConditionMask) != FALSE;
}

inline bool IsWindows7SP1OrGreater(void){
	return IsWindowsVersionOrGreater(HIBYTE(_WIN32_WINNT_WIN7), LOBYTE(_WIN32_WINNT_WIN7), 1);
}
#endif


//	CPUID 1 EDX
#define IA64_READY (1<<30)
#define HTT_READY (1<<8)
#define SSE2_READY (1<<26)
#define SSE_READY (1<<25)
#define MMX_READY (1<<23)
#define FPU_READY (1)

//	CPUID 1 ECX
#define AVX_READY (1<<28)
#define AES_READY (1<<25)
#define SSE42_READY (1<<20)
#define SSE41_READY (1<<19)
#define FMA_READY (1<<12)
#define SSSE3_READY (1<<9)
#define SSE3_READY (1)

//	CPUID 7 EBX
#define AVX512CD_READY (1<<28)
#define AVX512ER_READY (1<<27)
#define AVX512PF_READY (1<<26)
#define AVX512F_READY (1<<16)
#define AVX2_READY (1<<5)


// MSC o[W`FbN
inline int _MSC_CVER(void) {
	int cver = 0;
#if _MSC_VER==1400
	cver = 2005;
#endif
#if _MSC_VER==1500
	cver = 2008;
#endif
#if _MSC_VER==1600
	cver = 2010;
#endif
#if _MSC_VER==1700
	cver = 2012;
#endif
#if _MSC_VER==1800
	cver = 2013;
#endif
#if _MSC_VER==1900
	cver = 2015;
#endif
#if _MSC_VER==1910
	cver = 2017;
#endif

	return cver;
}


#if 1
int WINAPI WinMain(
	_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPSTR lpCmdLine,
	_In_ int nShowCmd
	)
#else
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
#endif
{
	UNREFERENCED_PARAMETER(hInstance);
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	UNREFERENCED_PARAMETER(nShowCmd);

	TCHAR	cpuname[4 * 4 * 4];
	TCHAR	inst[256];
	TCHAR	buf[256];
	int		cver = 0;
	TCHAR	*project;
	TCHAR	*win;
	TCHAR	*dll;


	// Debug ? Release
#ifdef _DEBUG
	project = _TEXT("Debug");
#else
	project = _TEXT("Release");
#endif

	// x64 ? Win32
#ifdef _WIN64
	win = _TEXT("x64");
#else
	win = _TEXT("Win32");
#endif

	// Multi
#if defined _MT
	#if defined _DLL
	dll = _TEXT("Dynamic Link (DLL)");
	#else
	dll = _TEXT("Static MultiThread");
	#endif
#endif

	// MSC Version
	cver = _MSC_CVER();
	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("Build: Visual C++ %i %s %s %s\r\n"), cver, project, win, dll);


	// CPU information
	{
		inst[0] = 0;
		cpuname[0] = 0;

		int CPUInfo[4];


		// CPU vendor ID
		{
			TCHAR	vendorID[12 + 1];
			int		cpuInfo[4];

			// "CPU vendor ID" ̎擾
			__cpuid(cpuInfo, 0);					// EAX=0: x_ID̎擾

			// EBX
			char* p = (char*)&cpuInfo[1];
			for (int j = 0; j < 4; ++j){
				vendorID[0 + j] = *p++;
			}
			// EDX
			p = (char*)&cpuInfo[3];
			for (int j = 0; j < 4; ++j){
				vendorID[4 + j] = *p++;
			}
			// EDC
			p = (char*)&cpuInfo[2];
			for (int j = 0; j < 4; ++j){
				vendorID[8 + j] = *p++;
			}
			vendorID[12] = 0;

			_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _T("Vendor ID: "));
			_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), vendorID);
			_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("\r\n"));
		}


		// CPU processor information
		{
			__cpuid(CPUInfo, 0x80000000);			// EAX=80000000h: T|[gőg@\ԍ̎擾
			if (0x80000004 <= CPUInfo[0]){			// vZbTuh̎擾\ł
				int CPUInfoV[3][4];
				__cpuid(CPUInfoV[0], 0x80000002);	// EAX=80000002h,80000003h,80000004h: vZbTuh
				__cpuid(CPUInfoV[1], 0x80000003);
				__cpuid(CPUInfoV[2], 0x80000004);
				char* p = (char*)CPUInfoV;
				for (int n = 0; n < 4 * 4 * 3; n++){
					cpuname[n] = *p++;
				}
				_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), cpuname);
				_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("\r\n"));
			}
		}


		// CPU supports ...
		{
			//	CPUID 1 EDX
			__cpuid(CPUInfo, 1);					// EAX=1: vZbTƃvZbT̋@\

			if (CPUInfo[3] & MMX_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("MMX "));
			}
			if (CPUInfo[3] & SSE_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("SSE "));
			}
			if (CPUInfo[3] & SSE2_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("SSE2 "));
			}


			//	CPUID 1 ECX
			if (CPUInfo[2] & SSE3_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("SSE3 "));
			}
			if (CPUInfo[2] & SSSE3_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("SSSE3 "));
			}
			if (CPUInfo[2] && FMA_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("FMA "));
			}
			if (CPUInfo[2] & SSE41_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("SSE4.1 "));
			}
			if (CPUInfo[2] & SSE42_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("SSE4.2 "));
			}
			if (CPUInfo[2] & AES_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AES "));
			}
			if (CPUInfo[2] & AVX_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AVX "));
			}


			// CPUID 7 EBX
			// __cpuidex(CPUInfo, 7, 0);
			__cpuid(CPUInfo, 7);

			if (CPUInfo[1] & AVX2_READY){
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AVX2 "));
			}
			if (CPUInfo[1] & AVX512F_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AVX512F "));
			}
			if (CPUInfo[1] & AVX512PF_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AVX512PF "));
			}
			if (CPUInfo[1] & AVX512ER_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AVX512ER "));
			}
			if (CPUInfo[1] & AVX512CD_READY) {
				_tcscat_s(inst, sizeof(inst) / sizeof(TCHAR), _TEXT("AVX512CD "));
			}

			if (inst[0]){
				_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("CPU support: "));
				_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), inst);
				_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("\r\n"));
			}
		}
	}


	// OS supports AVX ?
	if (IsWindows7SP1OrGreater()){
		_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("OS: AVX Suport"));
	}
	else{
		_tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("OS: AVX Not Suport"));
	}


	// ʕ\
	MessageBox(0, buf, _TEXT("VXeSIMD߂̃T|[g"), MB_OK);


	return (int)0;
}
